//+------------------------------------------------------------------+
//|                                                  TradeCopier.mq4 |
//|                                    Copyright  2007, fxtrader625 |
//|                                  http://www.forexampletrades.com |
//|                            Donation: paypal@forexampletrades.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, fxtrader625"
#property link      "http://www.forexampletrades.com"
#property library

#import "TradeSwitch.dll"
int SendSignal(string Name, string Value);
#import

//+------------------------------------------------------------------+
//| Library functions                                                |
//+------------------------------------------------------------------+
void CopyTrade(int ticket, bool reverse)
{
   if (OrderSelect(ticket, SELECT_BY_TICKET))
   {
      int cmd = OrderType();
      double volume = OrderLots();
      double price = OrderOpenPrice();
      double stoploss = OrderStopLoss();
      double takeprofit = OrderTakeProfit();
      switch (cmd)
      {
      case OP_BUY:
         // OrderSend,cmd,volume,stoploss,takeprofit,ticket
         if (!reverse)
         {
            SendSignal(Symbol(), "OrderSend,OP_BUY,"
               + volume + ","
               + "0,"
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(Symbol(), "OrderSend,OP_SELL,"
               + volume + ","
               + "0,"
               + takeprofit + ","
               + stoploss + ","
               + ticket);
         }
         break;
      case OP_SELL:
         // OrderSend,cmd,volume,stoploss,takeprofit,ticket
         if (!reverse)
         {
            SendSignal(Symbol(), "OrderSend,OP_SELL,"
               + volume + ","
               + "0,"
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(Symbol(), "OrderSend,OP_BUY,"
               + volume + ","
               + "0,"
               + takeprofit + ","
               + stoploss + ","
               + ticket);
         }
         break;
      case OP_BUYSTOP:
         if (!reverse)
         {
            SendSignal(Symbol(), "OrderSend,OP_BUYSTOP,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(Symbol(), "OrderSend,OP_SELLLIMIT,"
               + volume + ","
               + price + ","
               + takeprofit + ","
               + stoploss + ","
               + ticket);
         }
         break;
      case OP_SELLLIMIT:
         if (!reverse)
         {
            SendSignal(Symbol(), "OrderSend,OP_SELLLIMIT,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(Symbol(), "OrderSend,OP_BUYSTOP,"
               + volume + ","
               + price + ","
               + takeprofit + ","
               + stoploss + ","
               + ticket);
         }
         break;
      case OP_SELLSTOP:
         if (!reverse)
         {
            SendSignal(Symbol(), "OrderSend,OP_SELLSTOP,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(Symbol(), "OrderSend,OP_BUYLIMIT,"
               + volume + ","
               + price + ","
               + takeprofit + ","
               + stoploss + ","
               + ticket);
         }
         break;
      case OP_BUYLIMIT:
         if (!reverse)
         {
            SendSignal(Symbol(), "OrderSend,OP_BUYLIMIT,"
               + volume + ","
               + price + ","
               + stoploss + ","
               + takeprofit + ","
               + ticket);
         }
         else
         {
            SendSignal(Symbol(), "OrderSend,OP_SELLSTOP,"
               + volume + ","
               + price + ","
               + takeprofit + ","
               + stoploss + ","
               + ticket);
         }
         break;
      }
   }
}

void UpdateTrade(int ticket, bool reverse)
{
   if (OrderSelect(ticket, SELECT_BY_TICKET))
   {
      int cmd = OrderType();
      double price = OrderOpenPrice();
      double stoploss = OrderStopLoss();
      double takeprofit = OrderTakeProfit();
      switch (cmd)
      {
      case OP_BUY:
      case OP_SELL:
         // OrderModify,ticket,price,stoploss,takeprofit
         if (!reverse)
         {
            SendSignal(Symbol(), "OrderModify,"
               + ticket + ","
               + "0,"
               + stoploss + ","
               + takeprofit);
         }
         else
         {
            SendSignal(Symbol(), "OrderModify,"
               + ticket + ","
               + "0,"
               + takeprofit + ","
               + stoploss);
         }
         break;
      case OP_BUYSTOP:
      case OP_SELLSTOP:
      case OP_BUYLIMIT:
      case OP_SELLLIMIT:
         if (!reverse)
         {
            SendSignal(Symbol(), "OrderModify,"
               + ticket + ","
               + price + ","
               + stoploss + ","
               + takeprofit);
         }
         else
         {
            SendSignal(Symbol(), "OrderModify,"
               + ticket + ","
               + price + ","
               + takeprofit + ","
               + stoploss);
         }
         break;
      }
   }
}

void CloseTrade(int ticket, double volume = -1)
{
   SendSignal(Symbol(), "OrderClose," + ticket + "," + volume);
}

void DeleteTrade(int ticket)
{
   SendSignal(Symbol(), "OrderDelete," + ticket);
}

